#version 330 core

// Ouput data
layout(location = 0) out vec4 out_color;

uniform sampler2D base_texture;
uniform sampler2D scene_texture;
uniform int state;

uniform vec2 offset;
uniform float coefs[5];

//in vec2 UV;
in vec2 frag_texCoords;

void main(){
	float thresh = 0.6f;
	vec4 color = texture2D(base_texture, frag_texCoords);
	out_color = vec4(0.0,0.0,0.0,1.0);

	if(state==0){
		//create threshold image
		if(color.r > thresh && color.g > thresh && color.b > thresh){
			//out_color = vec4(color.r-thresh, color.g-thresh, color.b-thresh, color.a);
			out_color = vec4(1.0f, 1.0f, 1.0f, 1.0f);
		}
	} else if(state==1){
		//horizontal blur
		out_color += coefs[0]*texture2D(base_texture, frag_texCoords+vec2(-2*offset.x, 0.0f));
		out_color += coefs[1]*texture2D(base_texture, frag_texCoords+vec2(-1*offset.x, 0.0));
		out_color += coefs[2]*texture2D(base_texture, frag_texCoords);
		out_color += coefs[3]*texture2D(base_texture, frag_texCoords+vec2( 1*offset.x, 0.0f));
		out_color += coefs[4]*texture2D(base_texture, frag_texCoords+vec2( 2*offset.x, 0.0f));
		
	} else if(state==2){
		//vertical blur
		out_color += coefs[0]*texture2D(base_texture, frag_texCoords+vec2(0.0f, -2*offset.y));
		out_color += coefs[1]*texture2D(base_texture, frag_texCoords+vec2(0.0f, -1*offset.y));
		out_color += coefs[2]*texture2D(base_texture, frag_texCoords);
		out_color += coefs[3]*texture2D(base_texture, frag_texCoords+vec2(0.0f, 1*offset.y));
		out_color += coefs[4]*texture2D(base_texture, frag_texCoords+vec2(0.0f, 2*offset.y));
	}

}