#version 330 core

uniform vec2 near_far; // near and far plane for cm-cams
uniform vec3 CAM_POS_WS; // world space camera position

in vec4 position_WS;
vec4 c_pos;

void main(void) {

	c_pos = vec4(CAM_POS_WS, 1.0f);

	// calculate distance
	float WS_dist = distance(position_WS, c_pos);

	// map value to [0;1] by dividing by far plane distance
	float WS_dist_normalized = WS_dist / near_far.y;
	
	// write modified depth
	gl_FragDepth = WS_dist_normalized;
}