#version 330 core

// Ouput data
layout(location = 0) out vec4 color;

//uniform sampler2D texture;
uniform sampler2D base_texture;
uniform samplerCube cube_texture;
uniform int texType;

//in vec2 UV;
in vec2 VS_texCoords;

// RENDER FACES OF CUBE MAP TO SCREEN
void main(){
	
	if(texType==0) // 2D-Texture
	{
		color = texture2D(base_texture, VS_texCoords);
	}
	else{
		//top row
		if(VS_texCoords.y >= 0.6666){	
		
			//+Y face
			if(VS_texCoords.x >= 0.25 && VS_texCoords.x <= 0.5){	
				float x = (VS_texCoords.x - 0.25) * 8.0 - 1.0;
				float z = (VS_texCoords.y - 0.6666) * 6.0 - 1.0;
				color = texture(cube_texture, vec3(x, 1.0, z));
			}
			else 
				discard;
		}
		//mid row
		else if(VS_texCoords.y < 0.6666 && VS_texCoords.y > 0.33333){	
		
			//-X face
			if(VS_texCoords.x >= 0.0 && VS_texCoords.x <= 0.25){
				float z = 1.0 - (VS_texCoords.x) * 8.0;
				float y = (VS_texCoords.y - 0.3333) * 6.0 - 1.0;
				color = texture(cube_texture, vec3(-1.0, y, z));
			}

			//-Z face
			else if(VS_texCoords.x > 0.25 && VS_texCoords.x <= 0.5){
				float x = (VS_texCoords.x - 0.25) * 8.0 - 1.0;
				float y = (VS_texCoords.y - 0.3333) * 6.0 - 1.0;
				color = texture(cube_texture, vec3(x, y, -1.0));
			}

			//+X face
			else if(VS_texCoords.x > 0.5 && VS_texCoords.x <= 0.75){	
						float z = (VS_texCoords.x - 0.5) * 8.0 - 1.0;
						float y = (VS_texCoords.y - 0.3333) * 6.0 - 1.0;
						color = texture(cube_texture, vec3(1.0, y, z));
			}

			//+Z face
			else
			{
				float x = 1.0 - (VS_texCoords.x - 0.75) * 8.0;
				float y = (VS_texCoords.y - 0.3333) * 6.0 - 1.0;
				color = texture(cube_texture, vec3(x, y, 1.0));
			}
		}
	
		//bottom row
		else if(VS_texCoords.y <= 0.3333){
			
				//-Y face
				if(VS_texCoords.x >= 0.25 && VS_texCoords.x <= 0.5){
					float x = (VS_texCoords.x - 0.25) * 8.0 - 1.0;
					float z = 1.0 - (VS_texCoords.y) * 6.0;
					color = texture(cube_texture, vec3(x, -1.0, z));
				}
				else
					discard;
		}
	}
}